import parmepy as pp
import math
from parmepy.fields.continuous import Field
from parmepy.operator.analytic import Analytic
from parmepy.domain.obstacle.sphere import Sphere, HemiSphere
from parmepy.domain.obstacle.cylinder2d import Cylinder2D, SemiCylinder2D
from parmepy.domain.obstacle.plates import Plates
pi = math.pi
from parmepy.operator.penalization import Penalization
from parmepy.operator.monitors.printer import Printer
from parmepy.problem.simulation import Simulation


def vitesse(x, y, z):
    return x, y, z


def vitesse2(x, y):
    return x, y

nb = 33

Lx = Ly = Lz = 2
dom = pp.Box(dimension=3, length=[Lx, Ly, Lz], origin=[-1., -1., -1.])
dom2 = pp.Box(dimension=2, length=[Lx, Ly], origin=[-1., -1.])
resol3D = [nb, nb, nb]
resol2D = [nb, nb]

# Fields
scal = Field(domain=dom, name='Scalar')
op = Analytic(scal, formula=vitesse, resolutions={scal: resol3D})
scal2 = Field(domain=dom2, name='Scalar')
op2 = Analytic(scal2, formula=vitesse2, resolutions={scal2: resol2D})

op.setUp()
op2.setUp()
topo = dom.topologies[0]
coords = topo.mesh.coords

ff = scal.discreteFields[topo].data

ff[...] = 128

topo2 = dom2.topologies.values()[0]

ff2 = scal2.discreteFields[topo2].data
ff2[...] = 128
sphere = Sphere(dom, position=[0., 0., 0.], radius=0.5, porousLayers=[0.13])

hsphere = HemiSphere(dom, position=[0., 0., 0.],
                     radius=0.5, porousLayers=[0.13])

plates = Plates(dom, normal_dir=0, epsilon=0.1)
plates2 = Plates(dom2, normal_dir=1, epsilon=0.1)

cyl = Cylinder2D(dom2, position=[0., 0.], radius=0.5, porousLayers=[0.13])
hcyl = SemiCylinder2D(dom2, position=[0., 0.], radius=0.5, porousLayers=[0.13])

ind = hsphere.discretize(topo)

penal = Penalization(scal, [hsphere, plates], coeff=[1e6, 10],
                     resolutions={scal: resol3D})
penal2 = Penalization(scal2, [hcyl, plates2], coeff=[1e6, 10],
                      resolutions={scal2: resol2D})

penal.setUp()
penal2.setUp()
printer = Printer(fields=[scal2], frequency=1)
printer.setUp()
print scal.norm()
simulation = Simulation()
penal.apply(simulation)
penal2.apply(simulation)
printer.apply(simulation)
print "print ..."
print scal.norm()
