"""
@file monitoring.py
Global interface for monitors.
"""
from abc import ABCMeta, abstractmethod
from parmepy.operator.continuous import Operator
from parmepy.tools.timers import Timer


class Monitoring(Operator):
    """Abstract interface to monitoring operators."""

    __metaclass__ = ABCMeta

    @abstractmethod
    def __init__(self, variables, frequency, name=None):
        """ Constructor
        @param variables : list of fields to monitor.
        @param frequency : output rate.
        @param name : Monitor name.
        """
        Operator.__init__(self, variables, name=name)
        ## Monitor frequency
        self.freq = frequency
        ## Object to store computational times of lower level functions
        self.timer = Timer(self)

    def setUp(self):
        pass

    def finalize(self):
        print self.timer


if __name__ == "__main__":
    print __doc__
    print "- Provided class : Monitoring (abstract)."
    print Monitoring.__doc__


