"""
Unitary tests for parmepy.tools.timers module
"""
from parmepy.tools.timers import Timer, timed_function


class A_class(object):
    def __init__(self):
        self.name = 'A_class'
        self.timer = Timer(self)
        self.n = 0

    @timed_function
    def call(self):
        self.n += 1

    @timed_function
    def call_other(self):
        self.n += 10


def test_timer_from_decorator():
    a = A_class()
    assert a.n == 0
    a.call()
    assert len(a.timer.f_timers.keys()) == 1
    fun1 = a.timer.f_timers.keys()[0]
    assert a.n == 1  # the call function have been called
    assert len(a.timer.f_timers[fun1].times) == 1
    assert a.timer.f_timers[fun1].t == a.timer.f_timers[fun1].times[0]
    a.call()
    a.call_other()
    assert len(a.timer.f_timers.keys()) == 2
    fun2 = [f for f in a.timer.f_timers.keys() if f != fun1][0]
    assert a.n == 12  # the call and call_other functions have been called
    assert len(a.timer.f_timers[fun1].times) == 2
    assert a.timer.f_timers[fun1].t == \
        a.timer.f_timers[fun1].times[0] + a.timer.f_timers[fun1].times[1]
    assert len(a.timer.f_timers[fun2].times) == 1
    assert a.timer.f_timers[fun2].t == a.timer.f_timers[fun2].times[0]


if __name__ == '__main__':
    test_timer_from_decorator()

